/*++

Copyright (c) Sydus.

Module:

    Mutex_Posix.h

Authors:

    Sharvil Nanavati (sharvil) 2005-09-21

--*/

#pragma once

#include "base.h"
#include "IMutexImplementation.h"

#include <pthread.h>

class Mutex_Posix : public IMutexImplementation
{
	friend class Mutex;

	private:
		Mutex_Posix();
		~Mutex_Posix();

		bool TryLock();
		void Lock();
		void Unlock();

	private:
		pthread_mutex_t iMutex;
};
