/*++

Copyright (c) Sydus.

Module:

    Semaphore_Posix.h

Authors:

    Sharvil Nanavati (sharvil) 2005-09-23

--*/

#pragma once

#include "base.h"
#include "ISemaphoreImplementation.h"

#include <semaphore.h>

class Semaphore_Posix : public ISemaphoreImplementation
{
	public:
		explicit Semaphore_Posix(int32 count);
		~Semaphore_Posix();

		void Up();
		void Down();
		bool TryDown();

		int32 GetCount() const;

	private:
		sem_t iSemaphore;
};
