/*++

Copyright (c) Sydus.

Module:

    Crc16.h

Authors:

    Sharvil Nanavati (sharvil) 2005-11-22

--*/

#pragma once

#include "base.h"

class Crc16
{
	public:
		Crc16();
		~Crc16();

		uint16 Checksum(const BString & data) const;
		uint16 Checksum(const uint8 * data, uint32 length) const;

	private:
		static const uint16 KCrcLookup[256];
};
